//
// $Id: UnitTestRunner.h,v 1.7 2007/03/06 20:42:22 will_mason Exp $
//
// vi: set ft=objc:

/*
 * ObjectiveLib - a library of containers and algorithms for Objective-C
 *
 * Copyright (c) 2004-2007
 * Will Mason
 *
 * Portions:
 *
 * Copyright (c) 1994
 * Hewlett-Packard Company
 *
 * Copyright (c) 1996,1997
 * Silicon Graphics Computer Systems, Inc.
 *
 * Copyright (c) 1997
 * Moscow Center for SPARC Technology
 *
 * Copyright (c) 1999 
 * Boris Fomitchev
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * You may contact the author at will_mason@users.sourceforge.net.
 */


#import "CompositeUnitTest.h"

@interface UnitTestRunner : CompositeUnitTest
{
@protected
    OLVector*   missingTests;
    int         testsRun;
}

#if defined(OL_NO_OPENSTEP)
+ (id) initialize;
#else
+ (void) initialize;
#endif
+ (void) popTestInProcess;
+ (void) pushTestInProcess: (id)test;
+ (id) testInProcess;

- (id) init;
- (id) initWithOut: (FILE*)o err: (FILE*)e;
#if defined(OL_NO_OPENSTEP)
- (id) free;
#else
- (void) dealloc;
#endif

- (void) automaticallyLoadTests;
- (BOOL) isClass: (Class)target aTypeOf: (Class)cls;
- (void) loadTestsForClass: (Class)cls;
- (void) loadTestsForClasses: (Class*)array;
- (BOOL) runTestWithName: (const char*)name;
- (void) runTestsWithNames: (OLVector*)names;
- (void) summarize;

@end

